//-------------------------------------------------------------------------------------------------------------------------------------
//
// BumpMap
//
//-------------------------------------------------------------------------------------------------------------------------------------


//-------------------------------------------------------------------------------------------------------------------------------------
// SkinMeshParameter
//
//
//-------------------------------------------------------------------------------------------------------------------------------------

float4 lhtDir = {0.0f, 0.0f, -1.0f, 1.0f};							//light Direction 
float4 lightDiffuse = {0.6f, 0.6f, 0.6f, 1.0f};						// Light Diffuse
float4 MaterialAmbient : MATERIALAMBIENT;// = {0.1f, 0.1f, 0.1f, 1.0f};// 
float4 MaterialDiffuse : MATERIALDIFFUSE;// = {0.8f, 0.8f, 0.8f, 1.0f};// gUˌ

// Matrix Pallette
static const int MAX_MATRICES = 26;									// Boneő吔
float4x3    WorldMatrixArray[MAX_MATRICES] : WORLDMATRIXARRAY;		// {[s
float4x4    ViewProjection : VIEWPROJECTION;								// ViewProjectionMatrix

//-------------------------------------------------------------------------------------------------------------------------------------
//
// StaticMeshParameter
//
//-------------------------------------------------------------------------------------------------------------------------------------
float4x4 WorldViewProjection;

//------------------------------------------------------------------------------------------------
// BumpMapp[^
// 
//
//-------------------------------------------------------------------------------------------------
float4 vecLightDir;		// CgVector
float3 vecEyePos;		// _ʒu

float ScaleValue; // FZ䗦


// fJ[ƕ}bv
texture Decal;
texture NormalMap;

sampler DecalSampler = sampler_state
{
    Texture = <Decal>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;
    AddressU = Wrap;
    AddressV = Wrap;
};

sampler NormalSampler = sampler_state
{
    Texture = <NormalMap>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;
    AddressU = Wrap;
    AddressV = Wrap;
};


// ͍\
struct SKINBUMP_INPUT
{
    float4  Position             : POSITION;
    float4  BlendWeights    : BLENDWEIGHT;		// _Weight
    float4  BlendIndices    : BLENDINDICES;		// _Index
    float3  Normal          : NORMAL;			// 
    float3 Tangent	      : TANGENT0;
    float3  TextureCoord            : TEXCOORD0;		// TextureW
};

// o͍\
struct SKINBUMP_OUTPUT
{
    float4  Position     : POSITION;
    float2  TextureCoord    : TEXCOORD0;
    float3 Light: TEXCOORD1;	
    float3 Eye	: TEXCOORD2;
};


//-----------------------------------------------------------------------------------------------------------------------------
// Tv   : Diffuse߂֐
//    : Vector
// ߂l : DiffuseF
//-----------------------------------------------------------------------------------------------------------------------------
float3 Diffuse( float3 Normal )
{
    float CosTheta;
    
    CosTheta = max( 0.0f , dot(Normal, lhtDir.xyz));
       
       
    return (CosTheta);
}

//-------------------------------------------------------------------------------------------------------------------------------
// Tv : {[sIndexƂɒ_֐
//
//
//-------------------------------------------------------------------------------------------------------------------------------
SKINBUMP_OUTPUT VShade(SKINBUMP_INPUT Input, uniform int NumBones )
{
    SKINBUMP_OUTPUT   Output;
    float3      Position = 0.0f;
    float3      Normal = 0.0f;
    float3	    Tangent = 0.0f;    
    float       LastWeight = 0.0f;
     
    // _IndexƗpɈڂ
    int4 IndexVector = D3DCOLORtoUBYTE4( Input.BlendIndices );

    // _Weightƃ{[Indexڂ
    float BlendWeightsArray[4] = ( float[4] )Input.BlendWeights;
    int   IndexArray[4]        = ( int[4] )IndexVector;
    
    // calculate the pos/normal using the "normal" weights 
    //        and accumulate the weights to calculate the last weight
    
    //-------------------------------------------------------------------------------------------------------
    // Agr[g̒_WyѕZo
    //-------------------------------------------------------------------------------------------------------
    for (int iBone = 0; iBone < NumBones-1; iBone++)
    {
        LastWeight = LastWeight + BlendWeightsArray[iBone];
        
        Position += mul(Input.Position, WorldMatrixArray[IndexArray[iBone]]) * BlendWeightsArray[iBone];
        Normal += mul(Input.Normal, WorldMatrixArray[IndexArray[iBone]]) * BlendWeightsArray[iBone];
        // TangentVector
        	Tangent += mul( Input.Tangent , WorldMatrixArray[ IndexArray[ iBone ] ] ) *BlendWeightsArray[ iBone ];
    }
    
    LastWeight = 1.0f - LastWeight; 

    // Zoꂽ_Weightɉe󂯂钸_Zo
    Position += (mul(Input.Position, WorldMatrixArray[IndexArray[NumBones-1]]) * LastWeight);
    Normal += (mul(Input.Normal, WorldMatrixArray[IndexArray[NumBones-1]]) * LastWeight);
    Tangent += ( mul( Input.Tangent , WorldMatrixArray[ IndexArray[ NumBones - 1 ] ] ) * LastWeight ); 
    
    // [hˉeϊ
    Output.Position = mul(float4( Position.xyz, 1.0f ) , ViewProjection );

    // Vector𐳋K
    Normal = normalize(Normal);

    // Shade (Ambient + etc.)
    //o.Diffuse.xyz = MaterialAmbient.xyz + Diffuse(Normal) * MaterialDiffuse.xyz;
    //o.Diffuse.w = 1.0f;
    
    // ]vZ	
	float3 Binormal = cross(  Normal , Tangent );

	// ̕
	float3 Eye = vecEyePos - Position.xyz;
	
	Output.Eye.x = dot( Eye , Tangent );
	Output.Eye.y = dot( Eye , Binormal );
	Output.Eye.z = dot( Eye , Normal  );
	normalize( Output.Eye );

	float3 Light = vecLightDir.xyz;
	Output.Light.x = dot( Light , Tangent );
	Output.Light.y = dot( Light , Binormal );
	Output.Light.z = dot( Light , Normal );
	normalize( Output.Light );

    // TextureW͂̂܂
    Output.TextureCoord  = Input.TextureCoord.xy;

    return Output;
}

//---------------------------------------------------------------------------------------------
//
// StaticMeshVertexShader
//
//----------------------------------------------------------------------------------------------
SKINBUMP_OUTPUT StaticMeshVertexShader( float4  Position : POSITION,
 						     float3  Normal : NORMAL,
    						     float3 Tangent : TANGENT0,
    						      float2  TextureCoord : TEXCOORD0 )
{
	SKINBUMP_OUTPUT Output;
	
	// ˉeϊ
	Output.Position = mul( float4( Position.xyz, 1.0f  ) , WorldViewProjection );
	Output.TextureCoord = TextureCoord.xy;
	
	// ]	
	float3 Binormal = cross( Normal , Tangent );
	
	// ̕
	float3 Eye = vecEyePos - Position.xyz;
	
	Output.Eye.x = dot( Eye , Tangent );
	Output.Eye.y = dot( Eye , Binormal );
	Output.Eye.z = dot( Eye , Normal  );
	normalize( Output.Eye );

	float3 Light = vecLightDir.xyz;
	Output.Light.x = dot( Light , Tangent );
	Output.Light.y = dot( Light , Binormal );
	Output.Light.z = dot( Light , Normal );
	normalize( Output.Light );
	
	return Output;
}

//------------------------------------------------------------------------------------------------------------------------
//
// sNZVF[_
//
//------------------------------------------------------------------------------------------------------------------------
float4 PS( SKINBUMP_OUTPUT Input ) : COLOR 
{
	// }bv̕
	float3 Normal = 2.0 * tex2D( NormalSampler, Input.TextureCoord ).xyz - 1.0;
	float3 Reflect = reflect( -normalize( Input.Eye ) , Normal );	
	
	float Ambient = vecLightDir.w;						// ̋( Ȃ񂩋CɓȂ̂Œ )
	
	
	// fJ[ƕ}bv
	float4 	DiffuseTerm = tex2D( DecalSampler , Input.TextureCoord ) * ( max( 0 , dot( Normal , Input.Light ) ) );//+ Ambient ):<-s@PĂ悤Ɍ
	float4 SpecularTerm = 0.7 * pow( max( 0 , dot( Reflect , Input.Light )  ) , 8 );
	
	// vZʂƃbṼ}eA𔽉f
	float4 FinalColor = ( DiffuseTerm + SpecularTerm ) * ( ( MaterialDiffuse + MaterialAmbient ) / ScaleValue );// + Emissive + Specular );
	 
	 

    return FinalColor;
}

int CurNumBones = 2;
VertexShader vsArray[4] = {
				compile vs_2_0 VShade(1), 
                            compile vs_2_0 VShade(2),
                            compile vs_2_0 VShade(3),
                            compile vs_2_0 VShade(4)
                          };


//-----------------------------------------------------------------------------
//
// SkinMeshBumpMapping
//
//------------------------------------------------------------------------------
technique SkinMeshBumpMap
{
    pass Pass0
    {
	 CullMode = CCW;               // wʃJO
        VertexShader = ( vsArray[CurNumBones] );
        PixelShader = compile ps_2_0 PS();
    }
}

//--------------------------------------------------------------------------------
//
// StaticMesh
//
//--------------------------------------------------------------------------------
technique StaticMeshBumpMap
{
    pass Pass0
    {
	 CullMode = CCW;               // wʃJO
        VertexShader = compile vs_2_0 StaticMeshVertexShader();
        PixelShader = compile ps_2_0 PS();
    }
}