//-------------------------------------------------------------------------------------------------------------------------------------
//
// CNɂSellShader
//
//-------------------------------------------------------------------------------------------------------------------------------------


//---------------------------------------------------------------------
//
// SKinMesh
//
//---------------------------------------------------------------------
static const int MAX_MATRICES = 26;
float4x3 WorldMatrixArray[ MAX_MATRICES ] : WORLDMATRIXARRAY;
float4x4 ViewProjection : VIEWPROJECTIONMATRIX;


float4 InkColor;
float InkSize;


//-----------------------------------------------------------------------
//
// staticMesh
//
//-----------------------------------------------------------------------
float4x4 WorldViewProjection;
/*float4 InkColor;
float InkSize;*/

//-----------------------------------------------------------------------------------------------------------------------------------------
//
// SkinMesh͍\
//
//-----------------------------------------------------------------------------------------------------------------------------------------
struct VS_SKINNING
{
	float4 Pos			   : POSITION;
	float4 Normal		   : NORMAL;
	float4 BlendWeights    : BLENDWEIGHT;		// _Weight
    float4 BlendIndices    : BLENDINDICES;		// _Index
    float3 TextureCoord    : TEXCOORD0;		    // TextureW
};

struct VS_SKINNINGOUTPUT
{
	float4  Pos				: POSITION;
	float3  Normal			: NORMAL;
    float2  TextureCoord    : TEXCOORD0;
};


//------------------------------------------------------------------------------------------------
// Tv   : _XLjOĕVector3X3sŕϊ( Normalize͊eōs ) 
//    : XLbV͍\
// ߂l : XLbVo͍\
//------------------------------------------------------------------------------------------------
VS_SKINNINGOUTPUT Vertex_TransformNormal( VS_SKINNING Input , uniform int NumBones )
{
	// o͍\
	VS_SKINNINGOUTPUT Output;
	
	// MeshSkinParameter
	float3      Position = 0.0f;
    float3      NormalVector = 0.0f;    
    float       LastWeight = 0.0f;

    // Toon
    float3 _Normal = 0.0f;
    
     // _Index
    int4 IndexVector = D3DCOLORtoUBYTE4( Input.BlendIndices );

    // _Weightƃ{[Index
    float BlendWeightsArray[ 4 ] = ( float[ 4 ] )Input.BlendWeights;
    int   IndexArray[ 4 ]        = ( int[ 4 ] )IndexVector;
    
    //-------------------------------------------------------------------------------------------------------------------------------------------
    //
    // _ƕvZ
    //
    //-------------------------------------------------------------------------------------------------------------------------------------------
    for ( int iBone=0 ; iBone < NumBones - 1 ; iBone++ )
    {
        LastWeight = LastWeight + BlendWeightsArray[ iBone ];
        
        // _WƕVector{[sTransformϊA_Weight
        Position += mul( Input.Pos , WorldMatrixArray[ IndexArray[ iBone ] ] ) * BlendWeightsArray[ iBone ];
       
       // Vector]̂( 3X3s )ŕϊ
        NormalVector += mul( Input.Normal , (float3x3)WorldMatrixArray[ IndexArray[ iBone ] ] ) * BlendWeightsArray[ iBone ];
   }
    
    // _Weight1.0f( 100% )ŏIIȒ_WeightZ
    LastWeight = 1.0f - LastWeight;
    
    
    
    // Zoꂽ_Weightɉe󂯂钸_Zo
    Position += ( mul ( Input.Pos , WorldMatrixArray[ IndexArray[ NumBones - 1 ] ] ) * LastWeight );
    NormalVector += ( mul ( Input.Normal , (float3x3)WorldMatrixArray[ IndexArray[ NumBones - 1 ] ] ) * LastWeight ); // {[s
    
    
    Output.Pos = float4( Position , 1.0 );// |V[ɕύX΂
    Output.Normal = NormalVector;
    
    // Shade (Ambient + etc.)
    //Output.Diffuse.xyz = MaterialAmbient.xyz + Diffuse( NormalVector , LightDiffuse  ) * MaterialDiffuse.xyz;
    //Output.Diffuse.w = 1.0f;


    // TextureW
    Output.TextureCoord  = Input.TextureCoord.xy;
    
	return Output;
}


//--------------------------------------------------------------
// Tv : Ink̍W肷VertexShader
//  : 
// ߂lƏo
//--------------------------------------------------------------
void SellShaderInkVertexShader (

	VS_SKINNING Input ,
	uniform int NumBones ,
	out float4 Pos : POSITION
)
 {
 	 VS_SKINNINGOUTPUT Output = Vertex_TransformNormal( Input , NumBones );
	// _W
	float4 wvp_pos = mul( Output.Pos , ViewProjection );
	float4 wvp_normal = float4(mul(Output.Normal , ( float3x3 )ViewProjection ) , 0 );
	Pos = wvp_pos+normalize(wvp_normal) * InkSize * wvp_pos.w;
}

// sNZVF[_
float4 SellShaderInkPixcelShader() : COLOR
{
	return InkColor;
}

// _VF[_
void StaticSellInkVertexShader (
	float4 pos : POSITION,
	float3 normal : NORMAL,
	out float4 Pos : POSITION
) 
{
	// _W
	float4 wvp_pos = mul( pos , WorldViewProjection );
	
	// R̂ݕϊ
	float4 wvp_normal = float4( mul( normal , ( float3x3 )WorldViewProjection ) , 0 );
	Pos = wvp_pos + normalize( wvp_normal ) * InkSize * wvp_pos.w;
}


int CurNumBones = 2;
VertexShader VertexArray[ 4 ] =
			     { 
				compile vs_1_1 SellShaderInkVertexShader( 1 ), 
                            compile vs_1_1 SellShaderInkVertexShader( 2 ),
                            compile vs_1_1 SellShaderInkVertexShader( 3 ),
                            compile vs_1_1 SellShaderInkVertexShader( 4 )
                          };



//----------------------------------------------------------------------
//
// SkinMeshInkŕ`
//
//----------------------------------------------------------------------
technique SellInkRender
{
	
	pass Pass0
	{
		CullMode = CW;
		VertexShader = ( VertexArray[ CurNumBones ] );
		PixelShader = compile ps_1_1 SellShaderInkPixcelShader();
	}
}


//-------------------------------------------------------------------------
//
// staticMeshSellShader
//
//-------------------------------------------------------------------------
technique staticInk
{
	pass Pass0
	{
		// ʂ`
		CullMode = CW;
		VertexShader = compile vs_1_1 StaticSellInkVertexShader();
		PixelShader=compile ps_1_1 SellShaderInkPixcelShader();
	}
}
