//--------------------------------------------------------------------------------------------
//FxFileTv : SkinMeshDataDrain
//
//
//
//---------------------------------------------------------------------------------------------

#ifndef _SKIN_DATADRAIN_
#define _SKIN_DATADRAIN_

// SKinningLibLoad
#include "SKinnedMesh.fx"



float4x4 ViewProjection : VIEWPROJECTIONMATRIX;
float3 LightVector : LIGHTVECTOR;
float Width : CLIENT_WIDTH;
float Height : CLIENT_HEIGHT;
float NormalScale;
float PixelScale;

//---------------------------------------------------------------------------
// VF[_
//----------------------------------------------------------------------------


// VertexShader
void DataDrainVertexShader_Main (
	VS_SKINNING Input , uniform int NumBones, 
	out float4 Pos : POSITION, 
	out float4 VertexColor : COLOR0,
	out float2 MeshUV : TEXCOORD0,
	out float2 PixelXY : TEXCOORD1
) {

	 
	// ]̂݃XLjO
	VS_SKINNINGOUTPUT Output = Vertex_TransformNormal( Input , NumBones  );
	// _Wˉeϊ
	float4 WorldViewProjection_Pos = mul( float4( Output.Pos.xyz , 1.0f )  , ViewProjection );
	
	
	float4 WorldViewProjection_Normal = float4(mul( Output.Normal, (float3x3)ViewProjection), 0 );
	
	// _Ɉړ
	Pos = WorldViewProjection_Pos + normalize( WorldViewProjection_Normal ) * NormalScale * WorldViewProjection_Pos.w;
	
	// eNX`W
	MeshUV = Output.TextureCoord;
	
	// _F
	float3 w_normal = normalize( normalize(Output.Normal ));
	VertexColor = max( 0, dot( w_normal, -LightVector) ) * MaterialDiffuse + MaterialAmbient;
	VertexColor.a = MaterialDiffuse.a;
	
	// sNZgU̎Zo
	PixelXY = Pos.xy * 0.5f + 0.5f;
}

// PixcelShader
float4 DataDrainPixcelShader(
	float4 VertexColor : COLOR, 
	float2 MeshUV : TEXCOORD0,
	float2 PixelXY : TEXCOORD1
) : COLOR 
{
	float4 color;
	float x = PixelXY.x * Width , y = PixelXY.y * Height;
	
	
	// Pixcelʓɂꍇ
	if ( abs( x % PixelScale ) < 1.0f  && abs( y % PixelScale ) < 1.0f )
	{
		// Textureƒ_F̍
		color = tex2D( MeshSampler , MeshUV ) * VertexColor;
	}
	else 
	{
		//ʊȌꍇ͕`悵Ȃ
		color = float4( 0, 0, 0, 0 );
	}
	
	return color;
}

// {[ݒ
int CurNumBones = 2;
VertexShader vsDataDrainArray[4] = { 
				compile vs_2_0 DataDrainVertexShader_Main(1), 
                            compile vs_2_0 DataDrainVertexShader_Main(2),
                            compile vs_2_0 DataDrainVertexShader_Main(3),
                            compile vs_2_0 DataDrainVertexShader_Main(4)
                          };

//-----------------------------------------------------------------------
// eNjbN
//------------------------------------------------------------------------
technique SkinDataDrain 
{
	pass Pass0
	{
		// wʃJO
		CullMode = NONE;

	        VertexShader = ( vsDataDrainArray[CurNumBones] );
       			
		// Z
		SrcBlend = SRCALPHA;
		DestBlend = ONE;
		
		PixelShader=compile ps_2_0 DataDrainPixcelShader();
	}
}

#endif 
