//----------------------------------------------------------------------------
// FxFileTv : SkinMeshɌwʂKp
// 
//
//
//---------------------------------------------------------------------------
#ifndef _SKINMESHSTEALTH_
#define _SKINMESHSTEALTH_

static const int MAX_MATRICES = 26;
float4x3 WorldMatrixArray[ MAX_MATRICES ] : WORLDMATRIXARRAY;

float4 MaterialAmbient : MATERIALAMBIENT;						// 
float4 MaterialDiffuse : MATERIALDIFFUSE;						// gUˌ



float4x4 ViewProjection;

texture EnvTex;
float NormalScale; // ̕ɂ炷䗦

//---------------------------------------------------------------------
// eNX`Tv
//---------------------------------------------------------------------
sampler EnvSmp = sampler_state
{
	Texture=<EnvTex>;
	MipFilter=LINEAR;
	MinFilter=LINEAR;
	MagFilter=LINEAR;
	AddressU=CLAMP;
	AddressV=CLAMP;
};


//-----------------------------------------------------------------------------------------------------------------------------------------
//
// SkinMesh͍\
//
//-----------------------------------------------------------------------------------------------------------------------------------------
struct VS_SKINNING
{
	float4 Pos			   : POSITION;
	float4 Normal		   : NORMAL;
	float4 BlendWeights    : BLENDWEIGHT;		// _Weight
    float4 BlendIndices    : BLENDINDICES;		// _Index
    float3 TextureCoord    : TEXCOORD0;		    // TextureW
};

struct VS_SKINNINGOUTPUT
{
	float4  Pos				: POSITION;
	float3  Normal			: NORMAL;
    float2  TextureCoord    : TEXCOORD0;
};

//-----------------------------------------------------------------------------------------------------------------------------
// Tv   : Diffuse߂֐
//    : Vector
// ߂l : DiffuseF
//-----------------------------------------------------------------------------------------------------------------------------
/*float3 Diffuse( float3 Normal )
{
    float CosTheta;
    
    // xNgƃCgxNg̓ = Diffuse
    CosTheta = max( 0.0f , dot( Normal , LightVector.xyz ) );
       
       
    return ( CosTheta );
}*/
//------------------------------------------------------------------------------------------------
// Tv   : _XLjOĕVector3X3sŕϊ( Normalize͊eōs ) 
//    : XLbV͍\
// ߂l : XLbVo͍\
//------------------------------------------------------------------------------------------------
VS_SKINNINGOUTPUT Vertex_TransformNormal( VS_SKINNING Input , uniform int NumBones )
{
	// o͍\
	VS_SKINNINGOUTPUT Output;
	
	// MeshSkinParameter
	float3      Position = 0.0f;
    float3      NormalVector = 0.0f;    
    float       LastWeight = 0.0f;

    // Toon
    float3 _Normal = 0.0f;
    
     // _Index
    int4 IndexVector = D3DCOLORtoUBYTE4( Input.BlendIndices );

    // _Weightƃ{[Index
    float BlendWeightsArray[ 4 ] = ( float[ 4 ] )Input.BlendWeights;
    int   IndexArray[ 4 ]        = ( int[ 4 ] )IndexVector;
    
    //-------------------------------------------------------------------------------------------------------------------------------------------
    //
    // _ƕvZ
    //
    //-------------------------------------------------------------------------------------------------------------------------------------------
    for ( int iBone=0 ; iBone < NumBones - 1 ; iBone++ )
    {
        LastWeight = LastWeight + BlendWeightsArray[ iBone ];
        
        // _WƕVector{[sTransformϊA_Weight
        Position += mul( Input.Pos , WorldMatrixArray[ IndexArray[ iBone ] ] ) * BlendWeightsArray[ iBone ];
       
       // Vector]̂( 3X3s )ŕϊ
        NormalVector += mul( Input.Normal , (float3x3)WorldMatrixArray[ IndexArray[ iBone ] ] ) * BlendWeightsArray[ iBone ];
   }
    
    // _Weight1.0f( 100% )ŏIIȒ_WeightZ
    LastWeight = 1.0f - LastWeight;
    
    
    
    // Zoꂽ_Weightɉe󂯂钸_Zo
    Position += ( mul ( Input.Pos , WorldMatrixArray[ IndexArray[ NumBones - 1 ] ] ) * LastWeight );
    NormalVector += ( mul ( Input.Normal , (float3x3)WorldMatrixArray[ IndexArray[ NumBones - 1 ] ] ) * LastWeight ); // {[s
    
    
    Output.Pos = float4( Position , 1.0 );// |V[ɕύX΂
    Output.Normal = NormalVector;
    
    // Shade (Ambient + etc.)
 //   Output.Diffuse.xyz = MaterialAmbient.xyz + Diffuse( NormalVector , LightDiffuse  ) * MaterialDiffuse.xyz;
 //   Output.Diffuse.w = 1.0f;


    // TextureW
    Output.TextureCoord  = Input.TextureCoord.xy;
    
	return Output;
}

//---------------------------------------------------------------------------------
// Tv   : VertexShader
//    : XLjO֐Worldϊ_ , XLjO֐Worldϊ_
// ߂l܂͏o : _W , TextureUV
//---------------------------------------------------------------------------------
void StealthVertexShader (
	VS_SKINNING Input ,
	uniform int NumBones,
	out float4 Pos : POSITION,
	out float2 EnvUV : TEXCOORD0
	
) 
{
	VS_SKINNINGOUTPUT Output = Vertex_TransformNormal( Input , NumBones );
	
	// _WZo
	Pos = mul( Output.Pos , ViewProjection );
	
	//------------------------------------------------------------------------
	// eNX`W
	//------------------------------------------------------------------------
	
	// o( ViewProjectionϊ̂ŐK : XLjO֐ł͐KȂ̂ )
	float3 WorldViewProjection_Normal = normalize( mul( Output.Normal , (float3x3)ViewProjection ) );
	
	
	// }`TextureObjectTextureCoordZo
	EnvUV = ( Pos.xy + WorldViewProjection_Normal.xy * NormalScale ) / Pos.w * float2( 0.5f , -0.5f  ) + 0.5f;
}

//-------------------------------------------------------------------------------------------
// sNZVF[_
//-------------------------------------------------------------------------------------------
float4 StealthPixcelShader(
	float2 EnvUV : TEXCOORD0
) : COLOR 
{
	// VerTexShaderTexCoordZoʂo
	return tex2D( EnvSmp , EnvUV );
}

int CurNumBones = 2;
VertexShader VertexArray[ 4 ] = { 
							compile vs_2_0 StealthVertexShader( 1 ), 
                            compile vs_2_0 StealthVertexShader( 2 ),
                            compile vs_2_0 StealthVertexShader( 3 ),
                            compile vs_2_0 StealthVertexShader( 4 )
                          };
                          

//--------------------------------------------------------------------------------------------------------------------------------
//
// eNjbN
//
//--------------------------------------------------------------------------------------------------------------------------------
technique StealthSkinning
{
    pass Pass0
    {
		CullMode = CCW;               // wʃJO
        VertexShader = ( VertexArray[ CurNumBones ] );
        PixelShader = compile ps_2_0 StealthPixcelShader();
    }
}

#endif