//-------------------------------------------------------------------------------------------------------------------------------------
// XLjOEffect
//
//
//-------------------------------------------------------------------------------------------------------------------------------------

float4 lhtDir = {0.0f, 0.0f, -1.0f, 1.0f};							//light Direction 
float4 lightDiffuse = {0.6f, 0.6f, 0.6f, 1.0f};						// Light Diffuse
float4 MaterialAmbient : MATERIALAMBIENT;// = {0.1f, 0.1f, 0.1f, 1.0f};// 
float4 MaterialDiffuse : MATERIALDIFFUSE;// = {0.8f, 0.8f, 0.8f, 1.0f};// gUˌ

// Matrix Pallette
static const int MAX_MATRICES = 26;									// Boneő吔
float4x3    WorldMatrixArray[MAX_MATRICES] : WORLDMATRIXARRAY;		// {[s
float4x4    ViewProjection : VIEWPROJECTION;								// ViewProjectionMatrix
texture MeshTexture;


// SrtaticMesh

float4x4 WorldViewProjection;

// Tv
sampler MeshSmp = sampler_state
{
	Texture=<MeshTexture>;
	MipFilter=LINEAR;
	MinFilter=LINEAR;
	MagFilter=LINEAR;
};


// ͍\
struct VS_INPUT
{
    float4  Pos             : POSITION;
    float4  BlendWeights    : BLENDWEIGHT;		// _Weight
    float4  BlendIndices    : BLENDINDICES;		// _Index
    float3  Normal          : NORMAL;			// 
    float3  Tex0            : TEXCOORD0;		// TextureW
};

// o͍\
struct VS_OUTPUT
{
    float4  Pos     : POSITION;
    float4  Diffuse : COLOR;
    float2  Tex0    : TEXCOORD0;
};


//-----------------------------------------------------------------------------------------------------------------------------
// Tv   : Diffuse߂֐
//    : Vector
// ߂l : DiffuseF
//-----------------------------------------------------------------------------------------------------------------------------
float3 Diffuse( float3 Normal )
{
    float CosTheta;
    
    CosTheta = max( 0.0f , dot(Normal, lhtDir.xyz));
       
       
    return (CosTheta);
}

//-------------------------------------------------------------------------------------------------------------------------------
// Tv : {[sIndexƂɒ_֐
//
//
//-------------------------------------------------------------------------------------------------------------------------------
VS_OUTPUT VShade(VS_INPUT i, uniform int NumBones )
{
    VS_OUTPUT   o;
    float3      Pos = 0.0f;
    float3      Normal = 0.0f;    
    float       LastWeight = 0.0f;
     
    // _IndexƗpɈڂ
    int4 IndexVector = D3DCOLORtoUBYTE4( i.BlendIndices );

    // _Weightƃ{[Indexڂ
    float BlendWeightsArray[4] = ( float[4] )i.BlendWeights;
    int   IndexArray[4]        = ( int[4] )IndexVector;
    
    // calculate the pos/normal using the "normal" weights 
    //        and accumulate the weights to calculate the last weight
    
    //-------------------------------------------------------------------------------------------------------
    // Agr[g̒_WyѕZo
    //-------------------------------------------------------------------------------------------------------
    for (int iBone = 0; iBone < NumBones-1; iBone++)
    {
        LastWeight = LastWeight + BlendWeightsArray[iBone];
        
        Pos += mul(i.Pos, WorldMatrixArray[IndexArray[iBone]]) * BlendWeightsArray[iBone];
        Normal += mul(i.Normal, WorldMatrixArray[IndexArray[iBone]]) * BlendWeightsArray[iBone];
    }
    
    LastWeight = 1.0f - LastWeight; 

    // Zoꂽ_Weightɉe󂯂钸_Zo
    Pos += (mul(i.Pos, WorldMatrixArray[IndexArray[NumBones-1]]) * LastWeight);
    Normal += (mul(i.Normal, WorldMatrixArray[IndexArray[NumBones-1]]) * LastWeight); 
    
    // [hˉeϊ
    o.Pos = mul(float4(Pos.xyz, 1.0f), ViewProjection);

    // Vector𐳋K
    Normal = normalize(Normal);

    // Shade (Ambient + etc.)
    o.Diffuse.xyz = MaterialAmbient.xyz + Diffuse(Normal) * MaterialDiffuse.xyz;
    o.Diffuse.w = 1.0f;

    // TextureW͂̂܂
    o.Tex0  = i.Tex0.xy;

    return o;
}

//------------------------------------------------------------------------------------------------------------------------
//
// sNZVF[_
//
//------------------------------------------------------------------------------------------------------------------------
float4 PS( float2 MeshUV : TEXCOORD0 , float4  Diffuse : COLOR ) : COLOR 
{
	// SellShadersDiffuse͔fȂقǂ
	return tex2D( MeshSmp , MeshUV );// * Diffuse;
}


// _VF[_
void BasicVS (
	float4 pos : POSITION,
	float3 normal : NORMAL,
	float2 mesh_uv : TEXCOORD0,
	out float4 Pos : POSITION,
	out float2 MeshUV : TEXCOORD0
) {
	// _WAeNX`W
	Pos = mul(pos, WorldViewProjection );
	MeshUV = mesh_uv;

	// _F->͕sv
/*	float3 w_normal=normalize(mul(normal, (float3x3)World));
	Col=max(0, dot(w_normal, -Light))+Ambient;*/
	
}

int CurNumBones = 2;
VertexShader vsArray[4] = { 
				compile vs_1_1 VShade(1), 
                            compile vs_1_1 VShade(2),
                            compile vs_1_1 VShade(3),
                            compile vs_1_1 VShade(4)
                          };


//////////////////////////////////////
// Techniques specs follow
//////////////////////////////////////
technique t0
{
    pass p0
    {
		CullMode = CCW;               // wʃJO
        VertexShader = ( vsArray[CurNumBones] );
        PixelShader = compile ps_1_1 PS();
    }
}

//==============================================================
// eNjbN
technique StaticBasic
{
	pass Pass0
	{
		CullMode = CCW;               // wʃJO
		VertexShader=compile vs_1_1 BasicVS();
		PixelShader=compile ps_1_1 PS();
	}
}
