//-------------------------------------------------------------------------------------------------------------------------------------
// XLjOEffect
//
//
//-------------------------------------------------------------------------------------------------------------------------------------

float4 lhtDir = {0.0f, 0.0f, -1.0f, 1.0f};							//light Direction 
float4 lightDiffuse = {0.6f, 0.6f, 0.6f, 1.0f};						// Light Diffuse
float4 MaterialAmbient : MATERIALAMBIENT;// = {0.1f, 0.1f, 0.1f, 1.0f};// 
float4 MaterialDiffuse : MATERIALDIFFUSE;// = {0.8f, 0.8f, 0.8f, 1.0f};// gUˌ

// Matrix Pallette
static const int MAX_MATRICES = 26;									// Boneő吔
float4x3    mWorldMatrixArray[MAX_MATRICES] : WORLDMATRIXARRAY;		// {[s
float4x4    mViewProj : VIEWPROJECTION;								// ViewProjectionMatrix
//texture MeshTexture;



float4x4 WVProj;


//
// StealthParameter
//

float NormalScale; // ̕ɂ炷䗦
texture EnvTex;

// Tv
/*sampler MeshSmp = sampler_state
{
	Texture=<MeshTexture>;
	MipFilter=LINEAR;
	MinFilter=LINEAR;
	MagFilter=LINEAR;
};
*/
//---------------------------------------------------------------------
// eNX`Tv
//---------------------------------------------------------------------
sampler EnvSmp=sampler_state
{
	Texture=<EnvTex>;
	MipFilter=LINEAR;
	MinFilter=LINEAR;
	MagFilter=LINEAR;
	AddressU=CLAMP;
	AddressV=CLAMP;
};



// ͍\
struct VS_INPUT
{
    float4  Pos             : POSITION;
    float4  BlendWeights    : BLENDWEIGHT;		// _Weight
    float4  BlendIndices    : BLENDINDICES;		// _Index
    float3  Normal          : NORMAL;			// 
};

// o͍\
struct VS_OUTPUT
{
    float4  Pos     : POSITION;
    //float4  Diffuse : COLOR;
    float2 EnvUV : TEXCOORD0;
    //float2  Tex0    : TEXCOORD0;
};


//-----------------------------------------------------------------------------------------------------------------------------
// Tv   : Diffuse߂֐
//    : Vector
// ߂l : DiffuseF
//-----------------------------------------------------------------------------------------------------------------------------
/*float3 Diffuse( float3 Normal )
{
    float CosTheta;
    
    CosTheta = max( 0.0f , dot(Normal, lhtDir.xyz));
       
       
    return (CosTheta);
}
*/
//-------------------------------------------------------------------------------------------------------------------------------
// Tv : {[sIndexƂɒ_֐
//
//
//-------------------------------------------------------------------------------------------------------------------------------
VS_OUTPUT VShade( VS_INPUT i, uniform int NumBones )
{
    VS_OUTPUT   o;
    float3      Pos = 0.0f;
    float3      Normal = 0.0f;    
    float       LastWeight = 0.0f;
     
    // _IndexƗpɈڂ
    int4 IndexVector = D3DCOLORtoUBYTE4( i.BlendIndices );

    // _Weightƃ{[Indexڂ
    float BlendWeightsArray[4] = ( float[4] )i.BlendWeights;
    int   IndexArray[4]        = ( int[4] )IndexVector;
    
    // calculate the pos/normal using the "normal" weights 
    //        and accumulate the weights to calculate the last weight
    
    //-------------------------------------------------------------------------------------------------------
    // Agr[g̒_WyѕZo
    //-------------------------------------------------------------------------------------------------------
    for (int iBone = 0; iBone < NumBones-1; iBone++)
    {
        LastWeight = LastWeight + BlendWeightsArray[iBone];
        
        Pos += mul(i.Pos, mWorldMatrixArray[IndexArray[iBone]]) * BlendWeightsArray[iBone];
        Normal += mul(i.Normal, mWorldMatrixArray[IndexArray[iBone]]) * BlendWeightsArray[iBone];
    }
    
    LastWeight = 1.0f - LastWeight; 

    // Zoꂽ_Weightɉe󂯂钸_Zo
    Pos += (mul(i.Pos, mWorldMatrixArray[IndexArray[NumBones-1]]) * LastWeight);
    Normal += (mul(i.Normal, mWorldMatrixArray[IndexArray[NumBones-1]]) * LastWeight); 
    
    // [hˉeϊ
    o.Pos = mul( float4( Pos.xyz, 1.0f ), mViewProj );

    // Vector𐳋K
    Normal = normalize(Normal);

    // Shade (Ambient + etc.)
   // o.Diffuse.xyz = MaterialAmbient.xyz + Diffuse(Normal) * MaterialDiffuse.xyz;
    //o.Diffuse.w = 1.0f;

    // TextureW͂̂܂
   // o.Tex0  = i.Tex0.xy;
    
    
    // }`TextureObjectTextureCoordZo
	o.EnvUV = ( o.Pos.xy + Normal.xy * NormalScale ) / o.Pos.w * float2( 0.5f , -0.5f ) + 0.5f;

    return o;
}


//---------------------------------------------------------------------------------
// VertexShader
//---------------------------------------------------------------------------------
void staticStealthVS (
	float4 pos : POSITION,
	float3 normal : NORMAL,
	out float4 Pos : POSITION,
	out float2 EnvUV : TEXCOORD0
) 
{
	// _WZo
	Pos = mul( pos , WVProj );
	
	//------------------------------------------------------------------------
	// eNX`W
	//------------------------------------------------------------------------
	
	// o
	float3 wvp_normal = normalize( mul( normal , (float3x3)WVProj ) );
	
	
	// }`TextureObjectTextureCoordZo
	EnvUV = ( Pos.xy + wvp_normal.xy * NormalScale ) / Pos.w * float2( 0.5f , -0.5f ) + 0.5f;
}


//------------------------------------------------------------------------------------------------------------------------
//
// sNZVF[_
//
//------------------------------------------------------------------------------------------------------------------------
float4 PS( float2 EnvUV : TEXCOORD0 ) : COLOR 
{
	//return tex2D( MeshSmp , MeshUV ) * Diffuse;
	return tex2D( EnvSmp , EnvUV );
}


int CurNumBones = 2;
VertexShader vsArray[4] = { compile vs_1_1 VShade(1), 
                            compile vs_1_1 VShade(2),
                            compile vs_1_1 VShade(3),
                            compile vs_1_1 VShade(4)
                          };


//////////////////////////////////////
// Techniques specs follow
//////////////////////////////////////
technique SKinMeshStealth
{
    pass p0
    {
		CullMode = CCW;               // wʃJO
        VertexShader = ( vsArray[CurNumBones] );
        PixelShader = compile ps_2_0 PS();
    }
}

technique StaticmeshStealth 
{
	pass Pass0
	{
	CullMode = CCW;
	
	VertexShader = compile vs_1_1 staticStealthVS();
	PixelShader = compile ps_1_1 PS();
	}
}