//--------------------------------------------------------------------------------------------------------------------------------------------
// FxFileTv : _WorldϊĕԂ܂
// XLjO֐{́AXLbVDiffuse߂֐
//
//
//--------------------------------------------------------------------------------------------------------------------------------------------

#ifndef _SKINNEDMESH_
#define _SKINNEDMESH_


static const int MAX_MATRICES = 26;
float4x3 WorldMatrixArray[ MAX_MATRICES ] : WORLDMATRIXARRAY;
float4 MaterialAmbient : MATERIALAMBIENT;						// 
float4 MaterialDiffuse : MATERIALDIFFUSE;						// gUˌ

float4 LightDiffuse : LIGHTDIFFUSE;							// Cg̊


//---------------------------------------------------------------------------------------------------------------------------------------------
// XLbVTexture
//---------------------------------------------------------------------------------------------------------------------------------------------
texture MeshTexture;

sampler MeshSampler = sampler_state
{
	Texture = < MeshTexture >;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
};



//-----------------------------------------------------------------------------------------------------------------------------------------
//
// SkinMesh͍\
//
//-----------------------------------------------------------------------------------------------------------------------------------------
struct VS_SKINNING
{
	float4 Pos			   : POSITION;
	float4 Normal		   : NORMAL;
	float4 BlendWeights    : BLENDWEIGHT;		// _Weight
    float4 BlendIndices    : BLENDINDICES;		// _Index
    float3 TextureCoord    : TEXCOORD0;		    // TextureW
};

struct VS_SKINNINGOUTPUT
{
	float4  Pos				: POSITION;
	float3  Normal			: NORMAL;
    float4  Diffuse			: COLOR;
    float2  TextureCoord    : TEXCOORD0;
};

//-----------------------------------------------------------------------------------------------------------------------------
// Tv   : Diffuse߂֐
//    : Vector
// ߂l : DiffuseF
//-----------------------------------------------------------------------------------------------------------------------------
float3 Diffuse( float3 Normal , float3 LightVector )
{
    float CosTheta;
    
    // xNgƃCgxNg̓ = Diffuse
    CosTheta = max( 0.0f , dot( Normal , LightVector.xyz ) );
       
       
    return ( CosTheta );
}

//----------------------------------------------------------------------------------------------------------------------------------------
// Tv   : _XLjO֐
//    : XLbV͍\ , _e󂯂{[s̐
// ߂l : XLbVo͍\
//----------------------------------------------------------------------------------------------------------------------------------------
VS_SKINNINGOUTPUT Vertex_Skinning( VS_SKINNING Input , uniform int NumBones )
{
	// o͍\
	VS_SKINNINGOUTPUT Output;
	
	// MeshSkinParameter
	float3      Position = 0.0f;
    float3      NormalVector = 0.0f;    
    float       LastWeight = 0.0f;

     // _Index
    int4 IndexVector = D3DCOLORtoUBYTE4( Input.BlendIndices );

    // _Weightƃ{[Index
    float BlendWeightsArray[ 4 ] = ( float[ 4 ] )Input.BlendWeights;
    int   IndexArray[ 4 ]        = ( int[ 4 ] )IndexVector;
    
    //-------------------------------------------------------------------------------------------------------------------------------------------
    //
    // _ƕvZ
    //
    //-------------------------------------------------------------------------------------------------------------------------------------------
    for ( int iBone=0 ; iBone < NumBones - 1 ; iBone++ )
    {
        LastWeight = LastWeight + BlendWeightsArray[ iBone ];
        
        // _WƕVector{[sTransformϊA_Weight
        Position += mul( Input.Pos , WorldMatrixArray[ IndexArray[ iBone ] ] ) * BlendWeightsArray[ iBone ];
        NormalVector += mul( Input.Normal , WorldMatrixArray[ IndexArray[ iBone ] ] ) * BlendWeightsArray[ iBone ];
        
    }
    
    // _Weight1.0f( 100% )ŏIIȒ_WeightZ
    LastWeight = 1.0f - LastWeight;
    
    
    
    // Zoꂽ_Weightɉe󂯂钸_Zo
    Position += ( mul ( Input.Pos , WorldMatrixArray[ IndexArray[ NumBones - 1 ] ] ) * LastWeight );
    NormalVector += ( mul ( Input.Normal , WorldMatrixArray[ IndexArray[ NumBones - 1 ] ] ) * LastWeight ); // {[s    
    
    
  
    
    // Vector𐳋K
    Output.Normal = normalize(  NormalVector  );
    
    
    
    

    // DiffuseZo
    Output.Diffuse.xyz = MaterialAmbient.xyz + Diffuse( NormalVector , LightDiffuse  ) * MaterialDiffuse.xyz;
    Output.Diffuse.w = 1.0f;


    // TextureW
    Output.TextureCoord  = Input.TextureCoord.xy;
    
    

    
	return Output;
}

//------------------------------------------------------------------------------------------------
// Tv   : _XLjOĕVector3X3sŕϊ( Normalize͊eōs ) 
//    : XLbV͍\
// ߂l : XLbVo͍\
//------------------------------------------------------------------------------------------------
VS_SKINNINGOUTPUT Vertex_TransformNormal( VS_SKINNING Input , uniform int NumBones )
{
	// o͍\
	VS_SKINNINGOUTPUT Output;
	
	// MeshSkinParameter
	float3      Position = 0.0f;
    float3      NormalVector = 0.0f;    
    float       LastWeight = 0.0f;

    // Toon
    float3 _Normal = 0.0f;
    
     // _Index
    int4 IndexVector = D3DCOLORtoUBYTE4( Input.BlendIndices );

    // _Weightƃ{[Index
    float BlendWeightsArray[ 4 ] = ( float[ 4 ] )Input.BlendWeights;
    int   IndexArray[ 4 ]        = ( int[ 4 ] )IndexVector;
    
    //-------------------------------------------------------------------------------------------------------------------------------------------
    //
    // _ƕvZ
    //
    //-------------------------------------------------------------------------------------------------------------------------------------------
    for ( int iBone=0 ; iBone < NumBones - 1 ; iBone++ )
    {
        LastWeight = LastWeight + BlendWeightsArray[ iBone ];
        
        // _WƕVector{[sTransformϊA_Weight
        Position += mul( Input.Pos , WorldMatrixArray[ IndexArray[ iBone ] ] ) * BlendWeightsArray[ iBone ];
       
       // Vector]̂( 3X3s )ŕϊ
        NormalVector += mul( Input.Normal , (float3x3)WorldMatrixArray[ IndexArray[ iBone ] ] ) * BlendWeightsArray[ iBone ];
   }
    
    // _Weight1.0f( 100% )ŏIIȒ_WeightZ
    LastWeight = 1.0f - LastWeight;
    
    
    
    // Zoꂽ_Weightɉe󂯂钸_Zo
    Position += ( mul ( Input.Pos , WorldMatrixArray[ IndexArray[ NumBones - 1 ] ] ) * LastWeight );
    NormalVector += ( mul ( Input.Normal , (float3x3)WorldMatrixArray[ IndexArray[ NumBones - 1 ] ] ) * LastWeight ); // {[s
    
    
    Output.Pos = float4( Position , 1.0 );// |V[ɕύX΂
    Output.Normal = NormalVector;
    
    // Shade (Ambient + etc.)
    Output.Diffuse.xyz = MaterialAmbient.xyz + Diffuse( NormalVector , LightDiffuse  ) * MaterialDiffuse.xyz;
    Output.Diffuse.w = 1.0f;


    // TextureW
    Output.TextureCoord  = Input.TextureCoord.xy;
    
	return Output;
}


//-------------------------------------------------------------------------------------------------------------
// Tv   : XLbVPixcelShader
//    : MeshUV , Diffuse
// ߂l : PixcelColor
//-------------------------------------------------------------------------------------------------------------
float4 SkinPixcelShader( float2 TextureCoord : TEXCOORD0 ,  float4  Diffuse : COLOR ) : COLOR
{
	 tex2D( MeshSampler , TextureCoord ) * Diffuse;
}

#endif