// -------------------------------------------------------------
// staticObjectɑ΂ShadowShader
// 
//
// -------------------------------------------------------------

//----------------------------------------------------------------------------
//
// SkinMeshp[^
//
//-----------------------------------------------------------------------------
static const int MAX_MATRICES = 26;
float4x3 WorldMatrixArray[ MAX_MATRICES ] : WORLDMATRIXARRAY;

float4 LightDiffuse : LIGHTDIFFUSE;							// Cg̊

float4x4 LightViewProjection;		// [JˉeԂւ̍Wϊ



// -------------------------------------------------------------
// staticMeshO[oϐ
// -------------------------------------------------------------
float4x4 WorldViewProjection;		// [JˉeԂւ̍Wϊ
float4x4 WorldLightViewProjection;		// [JˉeԂւ̍Wϊ
float4x4 WorldLightViewProjectionUV;		// eNX`Wnւ̎ˉe
float4   MaterialDiffuse;		// bV̐F
float4	 LightVector;	// Cg̕

// -------------------------------------------------------------
// eNX`
// -------------------------------------------------------------
texture ShadowMap;
sampler ShadowMapSampler = sampler_state
{
    Texture = <ShadowMap>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;

    AddressU = Clamp;
    AddressV = Clamp;
};
// -------------------------------------------------------------
texture MeshTexture;
sampler DecaleMapSamp = sampler_state
{
    Texture = <MeshTexture>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;

    AddressU = Clamp;
    AddressV = Clamp;
};

//------------------------------------------------------------------------------------
//
// SkinMesh
//
//------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------------------------------
//
// SkinMesh͍\
//
//-----------------------------------------------------------------------------------------------------------------------------------------
struct VS_SKINNING
{
	float4 Pos			   : POSITION;
	float3 Normal		   : NORMAL;
	float4 BlendWeights    : BLENDWEIGHT;		// _Weight
    float4 BlendIndices    : BLENDINDICES;		// _Index
    float3 TextureCoord    : TEXCOORD0;		    // TextureW
};

struct VS_SKINNINGOUTPUT
{
	float4  Pos				: POSITION;
	float3  Normal			: NORMAL;
    	float2  TextureCoord    : TEXCOORD0;
};


// -------------------------------------------------------------
// _VF[_sNZVF[_ɓnf[^
// -------------------------------------------------------------
struct VS_OUTPUT
{
    float4 Pos			: POSITION;
	float4 Diffuse		: COLOR0;
	float4 Ambient		: COLOR1;
	float4 ShadowMapUV	: TEXCOORD0;
	float4 Depth		: TEXCOORD1;
	float2 DecaleTex	: TEXCOORD2;
};


//----------------------------------------------------------------------------------------------------------------------------------------
// Tv   : _XLjO֐
//    : XLbV͍\ , _e󂯂{[s̐
// ߂l : XLbVo͍\
//----------------------------------------------------------------------------------------------------------------------------------------
VS_SKINNINGOUTPUT Vertex_Skinning( VS_SKINNING Input , uniform int NumBones )
{
	// o͍\
	VS_SKINNINGOUTPUT Output;
	
	// MeshSkinParameter
	float3      Position = 0.0f;
    float3      NormalVector = 0.0f;    
    float       LastWeight = 0.0f;

     // _Index
    int4 IndexVector = D3DCOLORtoUBYTE4( Input.BlendIndices );

    // _Weightƃ{[Index
    float BlendWeightsArray[ 4 ] = ( float[ 4 ] )Input.BlendWeights;
    int   IndexArray[ 4 ]        = ( int[ 4 ] )IndexVector;
    
    //-------------------------------------------------------------------------------------------------------------------------------------------
    //
    // _ƕvZ
    //
    //-------------------------------------------------------------------------------------------------------------------------------------------
    for ( int iBone=0 ; iBone < NumBones - 1 ; iBone++ )
    {
        LastWeight = LastWeight + BlendWeightsArray[ iBone ];
        
        // _WƕVector{[sTransformϊA_Weight
        Position += mul( Input.Pos , WorldMatrixArray[ IndexArray[ iBone ] ] ) * BlendWeightsArray[ iBone ];
        NormalVector += mul( Input.Normal , WorldMatrixArray[ IndexArray[ iBone ] ] ) * BlendWeightsArray[ iBone ];
        
    }
    
    // _Weight1.0f( 100% )ŏIIȒ_WeightZ
    LastWeight = 1.0f - LastWeight;
    
    
    
    // Zoꂽ_Weightɉe󂯂钸_Zo
    Position += ( mul ( Input.Pos , WorldMatrixArray[ IndexArray[ NumBones - 1 ] ] ) * LastWeight );
    NormalVector += ( mul ( Input.Normal , WorldMatrixArray[ IndexArray[ NumBones - 1 ] ] ) * LastWeight ); // {[s    
    
    Output.Pos = float4( Position.xyz , 1.0f );
  
    
    // Vector𐳋K
    Output.Normal = normalize(  NormalVector  );

    // TextureW
    Output.TextureCoord  = Input.TextureCoord.xy;
    
    

    
	return Output;
}

// -------------------------------------------------------------
// 1pXځF_VF[_vO
// -------------------------------------------------------------
VS_OUTPUT VertexShader_SkinCreateShadowMap(
	VS_SKINNING Input ,
	uniform int NumBones
      //float4 Pos    : POSITION,          // f̒_
      //float3 Normal : NORMAL	         // f̖@
){
    VS_OUTPUT Out = (VS_OUTPUT)0;        // o̓f[^
    
    VS_SKINNINGOUTPUT SkiningOut = Vertex_Skinning( Input , NumBones );
    
    // LightԂɍWϊ
	float4 pos = mul( SkiningOut.Pos , LightViewProjection );
	
    // ʒuW
    Out.Pos = pos;
    
    // CgWnł̐[xeNX`ɓ
    Out.ShadowMapUV = pos;

    return Out;
}
// -------------------------------------------------------------
// 1pXځFsNZVF[_vO
// -------------------------------------------------------------
float4 PixcelShader_CreateShadowMap(VS_OUTPUT In) : COLOR
{   
    float4 Out;
    
    Out = In.ShadowMapUV.z / In.ShadowMapUV.w;
    
    return Out;
}


// -------------------------------------------------------------
// 1pXځF_VF[_vO
// -------------------------------------------------------------
VS_OUTPUT VertexShader_CreateShadowMap(
      float4 Pos    : POSITION,          // f̒_
      float3 Normal : NORMAL	         // f̖@
)
{
    VS_OUTPUT Out = (VS_OUTPUT)0;        // o̓f[^
    
    // Wϊ
	float4 pos = mul( Pos, WorldLightViewProjection );
	
    // ʒuW
    Out.Pos = pos;
    
    // JWnł̐[xeNX`ɓ
    Out.ShadowMapUV = pos;

    return Out;
}

// -------------------------------------------------------------
//
// VertexShader
//
// -------------------------------------------------------------
VS_OUTPUT VertexShader_RenderingShadow(
      float4 Pos    : POSITION,          // f̒_
      float3 Normal : NORMAL,	         // f̖@
      float2 Tex    : TEXCOORD0	         // eNX`W
){
    VS_OUTPUT Out = (VS_OUTPUT)0;        // o̓f[^
	float4	uv;
	
	// Wϊ
    Out.Pos = mul(Pos, WorldViewProjection);
	// F
	Out.Diffuse = MaterialDiffuse * max( dot(LightVector, Normal), 0);// gUF
	Out.Ambient = MaterialDiffuse * 0.3f;						     // F
	
	// VhE}bv : eNX`ԂɎˉeϊ
	Out.ShadowMapUV = mul( Pos , WorldLightViewProjectionUV );
	
	// r̂߂̐[xl
	Out.Depth       = mul(Pos, WorldLightViewProjection);
		
	// fJ[eNX`
	Out.DecaleTex   = Tex;
		
    return Out;
}
//----------------------------------------------------------------------------
//
// ShadowMap̕`
//
//----------------------------------------------------------------------------
float4 PixcelShader_RenderingShadow(VS_OUTPUT In) : COLOR
{   
	//-------------------------------------------------------------------------
	// staticShadowTextrureƁASkinObejctShadowTextureΗǂ̂낤H
	//------------------------------------------------------------------------
    	float4 Color;
	float  shadow = tex2Dproj( ShadowMapSampler, In.ShadowMapUV ).x;
	float4 decale = tex2D( DecaleMapSamp, In.DecaleTex );
    
    Color = In.Ambient + ( ( shadow * In.Depth.w < In.Depth.z - 0.03f ) ? 0 : In.Diffuse );

    return Color * decale;
}  

// SkinMesh
int CurNumBones = 2;
VertexShader CreateShadowArray[ 4 ] = { 
							compile vs_1_1 VertexShader_SkinCreateShadowMap( 1 ), 
                            compile vs_1_1 VertexShader_SkinCreateShadowMap( 2 ),
                            compile vs_1_1 VertexShader_SkinCreateShadowMap( 3 ),
                            compile vs_1_1 VertexShader_SkinCreateShadowMap( 4 )
                          };




// -------------------------------------------------------------
//
// ShadowMap쐬eNjbN
//
// -------------------------------------------------------------
technique CreateShadowMap
{
    pass Pass0// VhE}bv̍쐬
    {
        // VF[_
        VertexShader = compile vs_1_1 VertexShader_CreateShadowMap();
        PixelShader  = compile ps_2_0 PixcelShader_CreateShadowMap();
    }    
}

//------------------------------------------------------------------------------
//
// ShadowMap`悷eNjbN
//
//------------------------------------------------------------------------------
technique ShadowRender
{
   pass Pass0// eNX`
    {
        // VF[_
        VertexShader = compile vs_1_1 VertexShader_RenderingShadow();
        PixelShader  = compile ps_2_0 PixcelShader_RenderingShadow();
    }
}


// -------------------------------------------------------------
//
// ShadowMap쐬eNjbN
//
// -------------------------------------------------------------
technique SkinCreateShadowMap
{
    pass Pass0// VhE}bv̍쐬
    {
        // VF[_
        VertexShader =  ( CreateShadowArray[ CurNumBones ] );
        PixelShader  = compile ps_2_0 PixcelShader_CreateShadowMap();
    }
    
    
}